var tickerHandler = (function () {
    var _event_id = (typeof (Storage) !== 'undefined') ? Number(localStorage.getItem('ticker_event_id')) : 0;
    var ticker_html = '<div class="ticker" id="ticker"><div><p></p></div></div>';
    var ticker_style = '<style id="tickerStyle">.ticker,.ticker div{display:block;position:absolute}.ticker{opacity:0;z-index:16777271;height:25px;width:[RESOLUTION_WIDTH]px;overflow:hidden}.ticker div{min-width:[RESOLUTION_WIDTH]px;-webkit-transform:translate3d(0,0,0);white-space:nowrap;height:auto}.ticker div.marquee{-webkit-animation:[marqueeDirection] linear [marqueeSpeed]s 1}.ticker p{margin:0;padding:0;float:left;width:100%}@-webkit-keyframes marquee_ltr{from{-webkit-transform:translateX([ltr_from]%)}to{-webkit-transform:translateX([ltr_to]%)}}@-webkit-keyframes marquee_rtl{from{-webkit-transform:translateX([rtl_from]%)}to{-webkit-transform:translateX([rtl_to]%)}}</style>';
    var _tickers = {},
        _tickerSchedule = {},
        _repeatCnt = 0,
        _direction = '',
        _interval = 0,
        _setTimeOut,
        _setTimeInterval;

    function isNewEvent(event_id) {
        return _event_id !== event_id;
    }

    function init(event_id, ticker) {
        if (typeof ticker !== 'undefined') {
            tickerHandler.off();
            $('body').append(ticker_html);

            _event_id = event_id;
            if ((typeof (Storage) !== 'undefined')) {
                localStorage.setItem('ticker_event_id', event_id);
            }

            _tickers = ticker.tickers;
            _tickerSchedule = ticker.tickerSchedule;
            /* pick ticker message */
            var message = _tickers[0].message;
            var ticker_dir = _tickers[0].direction;
            var langCode = getCookie('active_language');
            if (langCode !== '') {
                $.each(_tickers, function (k, v) {
                    if (v.langCode === langCode) {
                        if (typeof v.direction === 'undefined') {
                            if ($.inArray(langCode, ['ar_DZ', 'ar_AE', 'fa_IR', 'he_IL']) > -1) {
                                ticker_dir = 'rtl';
                            }
                        } else {
                            ticker_dir = v.direction;
                        }
                        message = v.message;
                    }
                });
            }
            $('.ticker').html('<div><p dir="'+ticker_dir+'">' + message + '<pre>   </pre></p></div>');

            /* apply ticker styles */
            $('.ticker').css({
                'background-color': _tickerSchedule.textAttr.backgroundColor,
                'height': (parseInt(_tickerSchedule.textAttr.fontSize) + 20) + 'px',
                'line-height': (parseInt(_tickerSchedule.textAttr.fontSize) + 20) + 'px',
            });
            $('.ticker > div > p').css({
                'font-family': '"' + _tickerSchedule.textAttr.fontName + '"',
                'font-size': _tickerSchedule.textAttr.fontSize + 'px',
                'color': _tickerSchedule.textAttr.fontColor,
                'font-style': (Number(_tickerSchedule.textAttr.italic)) ? 'italic' : 'normal',
                'font-weight': (Number(_tickerSchedule.textAttr.bold)) ? 'bold' : 'normal',
                'text-decoration': ((Number(_tickerSchedule.textAttr.underline)) ? 'underline' : '') + ' ' + ((Number(_tickerSchedule.textAttr.strikethru)) ? 'line-through' : ''),
                'white-space' : 'nowrap'
            });
            if (_tickerSchedule.position === 'top') {
                $('.ticker').css('top', 0);
                $('.ticker').css('bottom', '');
            } else {
                $('.ticker').css('top', '');
                $('.ticker').css('bottom', 0);
            }

            /* set ticker animation */
            _repeatCnt = _tickerSchedule.repeat;
            _interval = _tickerSchedule.interval;

            /* [slow, medium, fast] : [24,12,8] is default marquee speed, [8,5,3] is weight for calculating marquee speed */
            var marqueeSpeed = [24,12,8][_tickerSchedule.speed] + (Math.ceil((message.length)/20) * [8,5,3][_tickerSchedule.speed]);
            var marqueeDirection = (_tickerSchedule.direction === 'right') ? "marquee_ltr" : "marquee_rtl";
            /*var new_rtl_from = parseInt((RESOLUTION_WIDTH/$(".ticker p")[0].scrollWidth)*100)+5;*/
            var new_rtl_from;
            if($(".ticker p")[0].scrollWidth >= RESOLUTION_WIDTH) {
            	new_rtl_from = parseInt((RESOLUTION_WIDTH/$(".ticker p")[0].scrollWidth)*100)+5;
            } else {
            	new_rtl_from = parseInt((RESOLUTION_WIDTH/RESOLUTION_WIDTH)*100)+5;
            }
            var tickerStyle = ticker_style
                .replace("[marqueeDirection]", marqueeDirection)
                .replace("[marqueeSpeed]", marqueeSpeed)
                .replace("[ltr_from]","-105")
                .replace("[ltr_to]","100")
                .replace("[rtl_from]",new_rtl_from+"")
                .replace("[rtl_to]","-105")
                .split('[RESOLUTION_WIDTH]').join(RESOLUTION_WIDTH);

            $("#tickerStyle").remove();
            $('head').append(tickerStyle);
            this.on(_repeatCnt, Number(_interval) * 60 * 1000);
        }
    }

    function on(repeatCnt, interval) {
        var is_show = false;
        logConsole('[TICKER] PORTAL_ACTIVE : ' + PORTAL_ACTIVE);
        if (typeof PORTAL_ACTIVE === 'undefined') {
            logConsole('[TICKER] PORTAL_ACTIVE is UNDEFINED');
        } else if (PORTAL_ACTIVE === false && _tickerSchedule.isActiveOnTV === '0') {
            logConsole('[TICKER] is not On TV and isActiveOnTv === 0');
        } else {
            logConsole('[TICKER] is On TV');
            is_show = true;
        }
        if (is_show === false) {
            if (--repeatCnt !== 0 && interval !== 0) {
                setTimeout(function () {
                    tickerHandler.on(repeatCnt, interval);
                }, interval);
            }
            return;
        }

        if (interval === 0) {
            $('.ticker div').css('-webkit-animation-iteration-count', repeatCnt);
        } else {
            $('.ticker div').css('-webkit-animation-iteration-count', '');
        }
        $('.ticker div').unbind();
        $('.ticker div').one('animationstart webkitAnimationStart', function (e) {
            $('.ticker').css('opacity', 1);
        });
        $('.ticker div').one('animationend webkitAnimationEnd MSAnimationEnd oAnimationEnd', function (e) {
            $('.ticker').css('opacity', 0);
            $('.ticker div').removeClass('marquee');
            if (--repeatCnt !== 0 && interval !== 0) {
                setTimeout(function () {
                    tickerHandler.on(repeatCnt, interval);
                }, interval);
            }
        });
        $('.ticker div').addClass("marquee");
    }

    function off() {
        $('.ticker').remove();
    }

    return {
        init: init,
        on: on,
        off: off,
        ticker_html: ticker_html,
        ticker_style: ticker_style,
        event_id: _event_id,
        set_time_out: _setTimeOut,
        set_time_interval: _setTimeInterval,
        is_new_event: isNewEvent
    };
}());
var notifierHandler = (function () {
    var _initialized = false;
    var _event_id = (typeof (Storage) !== 'undefined') ? Number(localStorage.getItem('notifier_event_id')) : 0;
    var notifier_html = '<div class="notifier"><span>You have 1 new message.</span></div>';
    var notifier_style = '<style>.notifier{z-index:16777271;display:none;padding:0px !important;background-size:40px 40px;box-shadow:inset 0 -1px 0 rgba(255, 255, 255, .4);width:100%;color:#fff;position:fixed;text-shadow:0 1px 0 rgba(0, 0, 0, .5);animation:animate-bg 5s linear infinite}.notifier{background-color:#4ea5cd;}.notifier span{margin:0 0 10px 30px !important;}.notifier p{margin:0}@keyframes animate-bg {from{background-position:0 0;}to{background-position:-80px 0;}}</style>';
    var messagesHeight = 0;
    var option = {
        timeout: 500,
        animation_time_out: 10000,
        interval: 60 * 1000 * 6
    };

    function show(notify) {
        var lastShowtime = (typeof (Storage) !== 'undefined') ? Number(localStorage.getItem('notifier_last_time')) : 0;
        var currentTime = new Date();
        currentTime = currentTime.getTime();
        logConsole("currentTime - lastShowtime : "+ (currentTime - lastShowtime));
        if ((currentTime - lastShowtime) >= option.interval) {
            if (typeof (Storage) !== 'undefined') {
                localStorage.setItem('notifier_last_time', currentTime);
            }
            $('.notifier').html('<span>You have ' + (notify.newNoticeCnt + notify.newPMSNoticeCnt) + ' new message(s).</span>');
            $('.notifier').show();
            $('.notifier').animate({ bottom: '0' }, option.timeout);
            setTimeout(function () {
                $('.notifier').animate({ bottom: '-200' }, option.timeout);
                $('.notifier').hide();
            }, option.animation_time_out);
        } else {
            logConsole('notifier_last_time < 60*1000*3');
        }
    }

    function init(notifierPopUpStyle, fontName) {
        if (_initialized === false) {
            $('head').append(notifier_style);
            $('body').append(notifier_html);
            _initialized = true;
        }
        messagesHeight = $('.notifier').outerHeight();
        $('.notifier').css({
            bottom: -messagesHeight,
            'font-family': '"' + fontName + '"',
            'font-size': notifierPopUpStyle.fontSize + 'px',
            color: notifierPopUpStyle.fontColor,
            'background-color': notifierPopUpStyle.boxColor,
            'border-radius': (notifierPopUpStyle.boxType === 'rectangle') ? 0 : '25px',
            'font-style': (Number(notifierPopUpStyle.italic)) ? 'italic' : 'normal',
            'font-weight': (Number(notifierPopUpStyle.bold)) ? 'bold' : 'normal',
            'text-decoration': ((Number(notifierPopUpStyle.underline)) ? 'underline' : '') + ' ' + ((Number(notifierPopUpStyle.strikethru)) ? 'line-through' : '')
        });
    }

    return {
        init: init,
        notifier_html: notifier_html,
        notifier_style: notifier_style,
        show: show
    };
}());
var QmsController = (function ($) {
    var TYPES = {
        gettvqmsservice: 'QMS_SERVICE_LIST',
        settvqmsrequest: 'QMS_NEW_WORK_ORDER',
        gettvqmsrequest: 'QMS_JOB_HISTORY'
    };
    var initialized = {
        SERVICE_LIST: false,
        JOB_HISTORY: false
    };
    var params = {
        action: '',
        md5: ''
    };
    function requestQmsLocalStorage(storageKey, callback) {
        var deferred = $.Deferred();
        if (callback == null) callback = $.noop;
        var localStorageKey = TYPES[params.action];
        var localStorageData = localStorage.getItem(storageKey);
        if (localStorageData !== null && localStorageKey !== TYPES.settvqmsrequest) {
            // callback(localStorageData, false);
            deferred.resolve(localStorageData);
        }

        return deferred.promise();
    }

    function getQmsJobHistoryLocalStorage(callback) {
        params.action = 'gettvqmsrequest';
        return requestQmsLocalStorage(callback);
    }

    function getQmsServiceList() {
        params.action = 'gettvqmsservice';
        window.requestHandler.requestQMS('gettvqmsservice', params);
    }

    function getQmsJobHistory() {
        params.action = 'gettvqmsrequest';
        window.requestHandler.requestQMS('gettvqmsrequest', params);
    }

    function getQmsJobHistoryAPI() {
        params.action = 'gettvqmsrequest';
        window.requestHandler.requestQMS('gettvqmsrequest', params);
    }

    function requestNewOrder(requestObj) {
        params.action = 'settvqmsrequest';
        params.requestCode = requestObj.code;
        if(!_.isUndefined(IS_NEORCHA) && IS_NEORCHA == "1") {
            params.requestType = 'concierge';
        } else {
            params.requestType = requestObj.type;
            if(requestObj.type == 'amenity') {
                params.description = {count: requestObj.amount};
            } else if(requestObj.type == 'channel') {
                params.description = {code: requestObj.code};
            } else {
                return;
            }
        }

        localStorage.setItem('requestNewOrder', 'Y');
        window.requestHandler.requestQMS('settvqmsrequest', params);
    }

    function init() {
        try {
            if(initialized.SERVICE_LIST && initialized.JOB_HISTORY) {
                window.requestHandler.publish('QMSREFRESH',{});
            } else {
                window.requestHandler.subscribe('gettvqmsservice', function(response){
                    console.log("gettvqmsservice : published");
                    localStorage.setItem('QMS_SERVICE_LIST', JSON.stringify(response.data));
                    initialized.SERVICE_LIST = true;
                    if(initialized.SERVICE_LIST && initialized.JOB_HISTORY) {
                        window.requestHandler.publish('QMSREFRESH',{});
                    }
                });
                window.requestHandler.subscribe('gettvqmsrequest', function(response){
                    console.log("gettvqmsrequest : published");
                    localStorage.setItem('QMS_JOB_HISTORY', JSON.stringify(response.data));
                    initialized.JOB_HISTORY = true;
                    if(initialized.SERVICE_LIST && initialized.JOB_HISTORY) {
                        window.requestHandler.publish('QMSREFRESH',{});
                    }
                });
                window.requestHandler.subscribe('settvqmsrequest', function(response){
                    console.log("settvqmsrequest : published");
                    localStorage.setItem('requestNewOrder', 'N');
                    getQmsJobHistory();
                });
                if (initialized.SERVICE_LIST === false) {
                    getQmsServiceList();
                }
                if (initialized.JOB_HISTORY === false) {
                    getQmsJobHistory();
                }
            }
        } catch (e) {
            logConsole('QmsController.init exception');
        }
    }

    function isInitialized() {
        return initialized;
    }

    function initialize() {
        initialized.SERVICE_LIST = false;
        initialized.JOB_HISTORY = false;
    }

    return {
        getQmsServiceList: getQmsServiceList,
        getQmsJobHistory: getQmsJobHistory,
        getQmsJobHistoryLocalStorage: getQmsJobHistoryLocalStorage,
        getQmsJobHistoryAPI: getQmsJobHistoryAPI,
        requestNewOrder: requestNewOrder,
        init: init,
        isInitialized: isInitialized,
        initialize: initialize,
        TYPES: TYPES
    };
}(jQuery));
var OpenQmsController = (function ($) {
    var TYPES = {
        gettvqmsservice: 'QMS_SERVICE_LIST',
        settvqmsrequest: 'QMS_NEW_WORK_ORDER',
        gettvqmsrequest: 'QMS_JOB_HISTORY'
    };
    var initialized = {
        CONTROLLER: false,
        SERVICE_LIST: false,
        JOB_HISTORY: false,
        DND_MUR: false,
        WAKE_UP_CALL : false
    };
    /*function requestQmsLocalStorage(storageKey, callback) {
        var deferred = $.Deferred();
        if (callback == null) callback = $.noop;
        var localStorageKey = TYPES[params.action];
        var localStorageData = localStorage.getItem(storageKey);
        if (localStorageData !== null && localStorageKey !== TYPES.settvqmsrequest) {
            // callback(localStorageData, false);
            deferred.resolve(localStorageData);
        }

        return deferred.promise();
    }

    function getQmsJobHistoryLocalStorage(callback) {
        params.action = 'gettvqmsrequest';
        return requestQmsLocalStorage(callback);
    }*/

    function getQmsServiceList() {
        window.requestHandler.requestQMS('gettvqmsservice', {
            action: 'gettvqmsservice',
            md5: ''
        });
    }

    function getQmsJobHistory() {
        window.requestHandler.requestQMS('gettvqmsrequest', {
            action: 'gettvqmsrequest',
            md5: ''
        });
    }
/*
    function getQmsJobHistoryAPI() {
        params.action = 'gettvqmsrequest';
        window.requestHandler.requestQMS('gettvqmsrequest', params);
    }
*/
    function requestNewOrder(requestObj) {
        var params = {
            action: 'settvqmsrequest',
            md5: '',
            requestCode: requestObj.code
        };
    
        if(!_.isUndefined(IS_NEORCHA) && IS_NEORCHA == "1") {
            params.requestType = 'concierge';
        } else {
            params.requestType = requestObj.type;
            if(requestObj.type == 'amenity') {
                params.description = {count: requestObj.amount};
            } else if(requestObj.type == 'channel') {
                params.description = {code: requestObj.code};
            } else {
                return;
            }
        }

        localStorage.setItem('requestNewOrder', 'Y');
        window.requestHandler.requestQMS('settvqmsrequest', params);
    }

    function requestNewService(requestCode, note) {
        var params = {
            action: 'settvqmsrequest',
            md5: '',
            description: note
        };

        switch(requestCode) {
            case 'laundry':
                params.requestType = 'service';
                params.requestCode = 'laundry';
                break;
            case 'shuttle' :
                params.requestType = 'reservation';
                params.requestCode = 'shuttle';
                break;
        }

        localStorage.setItem('requestNewOrder', 'Y');
        window.requestHandler.requestQMS('settvqmsrequest', params);
    }

    function init() {
        console.log("OpenQmsController init");
        if(initialized.CONTROLLER == false) {
            initialized.CONTROLLER = true;
            console.log("OpenQmsController subscribed");
            try {
                window.requestHandler.subscribe('gettvqmsservice', function(response){
                    console.log("gettvqmsservice : published");
                    console.log(response);
                    if(_.isArray(response.data) && response.data.length > 1 && !_.isUndefined(response.data[0].requestId)) {
                        console.log("wrong data");
                    } else {
                        localStorage.setItem('QMS_SERVICE_LIST', JSON.stringify(response.data));
                    }

                    /*window.requestHandler.publish('QMSTVSERVICE',{});*/
                    /*refreshService();*/

                    getQmsJobHistory();
                });
                window.requestHandler.subscribe('gettvqmsrequest', function(response){
                    console.log("gettvqmsrequest : published");
                    console.log(response);
                    localStorage.setItem('QMS_JOB_HISTORY', JSON.stringify(response.data));

                    /*window.requestHandler.publish('QMSTVREQUEST',{});*/
                    try {    refreshService();   } catch(e) {   logConsole('Exception occurred when called refreshService ');    }
                    try {    refreshHistory();   } catch(e) {   logConsole('Exception occurred when called refreshHistory ');    }
                    try {    refreshDNDMUR();   } catch(e) {   logConsole('Exception occurred when called refreshDNDMUR ');    }
                    try {    refreshWakeUpCall();   } catch(e) {   logConsole('Exception occurred when called refreshWakeUpCall ');    }
                });
                window.requestHandler.subscribe('settvqmsrequest', function(response){
                    console.log("settvqmsrequest : published");
                    console.log(response);
                    localStorage.setItem('requestNewOrder', 'N');
                    getQmsJobHistory();
                });
                window.requestHandler.subscribe('updatetvqmsrequest', function(response){
                    console.log("updatetvqmsrequest : published");
                    console.log(response);
                    localStorage.setItem('requestNewOrder', 'N');
                    getQmsJobHistory();
                });
            } catch (e) {
                logConsole('OpenQmsController.init exception');
            }
        }
    }

    function initService() {
        if(initialized.SERVICE_LIST == false) {
            initialized.SERVICE_LIST = true;
            console.log("Added subscription of OpenQms service");
        }
    }
    function refreshService() {
        if(initialized.SERVICE_LIST == true) {
            var fDoc = window.parent.document.getElementById('iframe_id');
            if(typeof fDoc.contentWindow.OpenQmsViewController == 'object' && typeof fDoc.contentWindow.OpenQmsViewController.refresh === 'function') {
                fDoc.contentWindow.OpenQmsViewController.refresh();
            }
        }
    }

    function initHistory() {
        if(initialized.JOB_HISTORY == false) {
            initialized.JOB_HISTORY = true;
            console.log("Added subscription of OpenQms history");
        }
    }
    function refreshHistory() {
        if(initialized.JOB_HISTORY == true) {
            var fDoc = window.parent.document.getElementById('iframe_id');
            if(typeof fDoc.contentWindow.OpenQmsHistoryController == 'object' && typeof fDoc.contentWindow.OpenQmsHistoryController.refresh === 'function') {
                fDoc.contentWindow.OpenQmsHistoryController.refresh();
            }
        }
    }

    function initDNDMUR() {
        if(initialized.DND_MUR == false) {
            initialized.DND_MUR = true;
            console.log("Added subscription of OpenQms DND_MUR");
        }
    }
    function refreshDNDMUR() {
        if(initialized.DND_MUR == true) {
            var fDoc = window.parent.document.getElementById('iframe_id');
            if(typeof fDoc.contentWindow.HousekeepingHandler == 'object' && typeof fDoc.contentWindow.HousekeepingHandler.refresh === 'function') {
                fDoc.contentWindow.HousekeepingHandler.refresh();
            }
        }
    }

    function initWakeUpCall() {
        if(initialized.WAKE_UP_CALL == false) {
            initialized.WAKE_UP_CALL = true;
            console.log("Added subscription of OpenQms WAKE_UP_CALL");
        }
    }

    function refreshWakeUpCall() {
        if(initialized.WAKE_UP_CALL == true) {
            var fDoc = window.parent.document.getElementById('iframe_id');
            if(typeof fDoc.contentWindow.wakeupCallController == 'object' && typeof fDoc.contentWindow.wakeupCallController.refresh === 'function') {
                fDoc.contentWindow.wakeupCallController.refresh();
            }
        }
    }

    return {
        init: init,
        initService: initService,
        initHistory: initHistory,
        initDNDMUR: initDNDMUR,
        initWakeUpCall: initWakeUpCall,
        getQmsServiceList: getQmsServiceList,
        getQmsJobHistory: getQmsJobHistory,
        /*getQmsJobHistoryLocalStorage: getQmsJobHistoryLocalStorage,*/
        /*getQmsJobHistoryAPI: getQmsJobHistoryAPI,*/
        requestNewOrder: requestNewOrder,
        requestNewService: requestNewService,
        TYPES: TYPES
    };
}(jQuery));
$(document).ready(function () {
    $('#iframe_id').on("load", function() {
        if(typeof COM_TYPE !== "undefined" && COM_TYPE === 'IP') {
            window.requestHandler.getEventMsg();
        }
    });

    var events = ['ticker'];
    $('head').append(tickerHandler.ticker_style);
    $('body').append(tickerHandler.ticker_html);

    window.requestHandler.subscribe('ticker', function(parsedJSON){
        console.log('ticker subscribe');
        console.debug("*********parsedJSON " + JSON.stringify(parsedJSON));
        try {
            if ($.isEmptyObject(parsedJSON) === false) {
                if (parsedJSON.tickers.length > 0) {
                    if (tickerHandler.is_new_event(Number(parsedJSON.tickerId))) {
                        if (tickerHandler.set_time_out !== undefined) {
                            clearTimeout(tickerHandler.set_time_out);
                            tickerHandler.set_time_out = undefined;
                        }
                        if (tickerHandler.set_time_interval !== undefined) {
                            clearInterval(tickerHandler.set_time_interval);
                            tickerHandler.set_time_interval = undefined;
                        }

                        var tickerScheduleData = parsedJSON.tickerSchedule;
                        var newTicker = {
                            "tickers": parsedJSON.tickers,
                            "tickerSchedule": tickerScheduleData
                        };

                        if (tickerScheduleData.startTime === -1) {
                            tickerHandler.init(Number(parsedJSON.tickerId), newTicker);
                        } else {
                            /* set time on */
                            var currentDate = new Date();
                            var startDelay = Number(tickerScheduleData.startTime) - (currentDate.getHours() * 60 + currentDate.getMinutes());
                            if (startDelay < 0) {
                                startDelay += 1440;
                            }
                            tickerHandler.set_time_out = setTimeout(function () {
                                tickerHandler.init(Number(parsedJSON.tickerId), newTicker);
                                tickerHandler.set_time_interval = setInterval(function () {
                                    tickerHandler.init(Number(parsedJSON.tickerId), newTicker);
                                }, 1440 * 60 * 1000);
                            }, startDelay * 60 * 1000);

                        }
                    } else {
                        logConsole("isn't new event");
                    }
                }
            }
        } catch (e) {
            console.debug(e);
        }
    }, false);

    if (_.isEmpty(events) === false && $.isPlainObject(window.requestHandler)) {
        window.requestHandler.getEvents(events);
    }
});
